﻿module.exports.parseDependencies = function parseDependencies(dependencyArray) {
    if (!dependencyArray || !dependencyArray.length) return [];

    var parsedArray = [];
    dependencyArray.forEach(function (depStr) {
        depStr = depStr.trim();
        var deps = depStr.split(';');
        deps.forEach(function (d) {
            d = d.trim();
            var threeParts = d.split('@'); //Must contain exactly 3 parts - appname, branch and build
            if (threeParts.length != 3)
                throw 'Invalid dependency: ' + d;

            var appName = threeParts[0].trim();
            var branch = threeParts[1].trim();
            var build = threeParts[2].trim();
            if (!appName.length)
                throw 'Missing appName: ' + d;
            if (!branch.length)
                throw 'Missing branch: ' + d;
            if (!build.length)
                throw 'Missing build: ' + d;

            parsedArray.push({ appName: appName, build: build, branch: branch });
        });
    });
    return parsedArray;
}