﻿//Duplicate code from sl-node-cover / instrumenter.js #875
function guessMethodName(functionNode, parent){
    var node = functionNode;
    var anc = parent;
    //guess method name
    var guessName = node.id && node.id.name;
    if (!guessName) {
        if (anc) {
            switch (anc.type) {
                case "VariableDeclarator":
                    if (anc.id && anc.id.type == "Identifier") {
                        guessName = anc.id.name;
                    }
                    break;
                case "Property":
                    if (anc.key && anc.key.type == "Identifier") {
                        guessName = anc.key.name;
                    }
                    break;
                case "AssignmentExpression":
                    if (anc.left && anc.left.type == "MemberExpression" && anc.left.property && anc.left.property.type == "Identifier") {
                        guessName = anc.left.property.name;
                    }
                    else if (anc.left && anc.left.type == "Identifier") {
                        guessName = anc.left.name;
                    }
                    break;
                case "CallExpression":
                    //This is an anonymous function passed to a function, nothing useful to add
                    break;
                default:                    
                    break;
            }
        }
    }
    return guessName;
}
module.exports.guessMethodName = guessMethodName;