﻿var Promise = require('promise'),
    util = require('util'),
    debuglog = util.debuglog ? util.debuglog('sl') : require('./alt-debug-log.js').debuglog('sl');

function NewDiffService(cfg, needle) {
    this.submitMapping = function (mapping) {
        var promise = new Promise(function (resolve, reject) {
            var opts = {
                json: true,
                compressed: true
            };
            if (cfg.proxy) //http://user:pass@proxy.server.com:3128
                opts.proxy = cfg.proxy;

            var url = cfg.server + '/v1/buildmapping';
            debuglog('Submitting build mapping: ' + JSON.stringify(mapping, null, '\t'));
            needle.post(url, mapping, opts, function (err, resp, body) {
                if (!err && resp.statusCode >= 300) {
                    err = new Error("Server returned status code " + resp.statusCode + ": " + resp.body);
                }
                debuglog('Submitted ' + (err ? 'with error' : 'succesfully'));
                if (err) {
                    debuglog(err.toString(), null, '\t');
                    reject(err);
                }
                else {
                    resolve(resp.body);
                }
            });
        });

        return promise;
    }
}

module.exports.NewDiffService = NewDiffService;